#include "bits/stdc++.h"
using namespace std;
#define LL long long
#define int LL
#define PB push_back
#define VI vector<int>
#define FOR(i,a,b) for(int i = (a); i <= (b); i++)
#define REP(i,n) FOR(i, 0, (int)n - 1)
#define PII pair<int,int>
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())
#define st first
#define nd second

template<class C> void mini(C & a4, C b4){a4 = min(a4, b4);}
template<class C> void maxi(C & a4, C b4){a4 = max(a4, b4);}

template<class TH> void _dbg(const char * sdbg, TH h){
	cerr<<sdbg<<'='<<h<<endl;
}
template<class TH, class... TA> void _dbg(const char * sdbg, TH h, TA... a){
	while(*sdbg!=',')
		cerr<<*sdbg++;
	cerr<<'='<<h<<",";
	_dbg(sdbg + 1, a...);
}
template<class T> ostream & operator<<(ostream & os, vector<T> V){
	os<<"[";for(auto vv: V) os <<vv<<","; return os <<"[";
}
template<class L, class R> ostream & operator<<(ostream & os , pair<L,R> P){
	return os << "(" << P.st <<","<<P.nd<<")";
}
#ifdef LOCAL
#define debug(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
#else
#define debug(...) (__VA_ARGS__)
#define cerr if(0) cout
#endif 

const int MAX_X = 50, MAX_Y = 100000;

int q;
int rep[(MAX_X + 5) * (MAX_Y + 5)];
int jumpArr[MAX_X + 5][MAX_Y + 5];


int id(int x, int y) {
	return MAX_X * y + x;
}

int find(int w) {
	return rep[w] = (rep[w] == w ? w : find(rep[w]));
}

void Union(int a, int b) {
	a = find(a);
	b = find(b);
	rep[a] = b;
}

int jump(int x, int y) {
	return jumpArr[x][y] = (jumpArr[x][y] == y ? y : jump(x, jumpArr[x][y]));
}

void connectPaths(int x, int x2, int y) {
	Union(id(x, y), id(x2, y));
}

void joinPath(int x, int yFrom, int yTo) {
	int y = yTo;
	while (true) {
		y = jump(x, y);
		if (y - 1 >= yFrom) {
			Union(id(x, y), id(x, y - 1));
			jumpArr[x][y] = y - 1;
		} else {
			break;
		}
	}
}

void insert(int xFrom, int yFrom, int xTo, int yTo) {
	for (int x = xFrom; x <= xTo; x++) {
		joinPath(x, yFrom, yTo);
		if (x < xTo) {
			connectPaths(x, x + 1, yTo);
		}
	}
}

int32_t main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	
	for (int i = 1; i <= MAX_X; i++) {
		for (int j = 1; j <= MAX_Y; j++) {
			rep[i] = id(i, j);
			jumpArr[i][j] = j;
		}
	}
	cin >> q;
	while (q--) {
		int t, xFrom, xTo, yFrom, yTo;
		cin >> t >> xFrom >> yFrom >> xTo >> yTo;
		if (xFrom > xTo) {
			swap(xFrom, xTo);
			swap(yFrom, yTo);
		}
		
		if (t == 0) {
			insert(xFrom, yFrom, xTo, yTo);
		} else {
			if (find(id(xFrom, yFrom)) == find(id(xTo, yTo))) {
				cout << 1 << "\n";
			} else {
				cout << 0 << "\n";
			}
		}
	}
}
